// -*- C++ -*- //

#ifndef MAP_WIN_H
#define MAP_WIN_H

class MapWin;

#include <all_include.h>
#include <main_win.h>
#include <libgnomecanvasmm.h>
#include <libgnomecanvasmm/polygon.h>

///This class is responsible for creating a window,
///on which the visualization attributes can be
///assigned to maps.
class MapWin : public Gtk::Window
{

  class MapSelector : public Gtk::HBox
  {
  protected:
    sigc::signal<void, std::string> signal_cbt;
    sigc::signal<void, bool> signal_newmapwin;

    int id;

    bool itisedge;

    bool default_state;

    bool set_new_map;

    Gtk::ComboBoxText cbt;

    Gtk::Button * newbut, * defbut;

    Gtk::HBox hbox;

    Gtk::Label * label;

  public:

    MapSelector(std::vector<std::string>, std::string, int, bool);

    sigc::signal<void, std::string> signal_cbt_ch();
    sigc::signal<void, bool> signal_newmapwin_needed();

    void update_list( std::vector<std::string> );

    ///If a radiobutton is clicked, this function determines
    ///which button was that and after that calls the
    ///appropriate function of the \ref GraphDisplayerCanvas
    ///to change the visible values of that attribute.
    virtual void comboChanged();

    virtual void new_but_pressed();

    virtual void reset();

    Glib::ustring get_active_text();
    void set_active_text(Glib::ustring);
    void append_text(Glib::ustring);
  };



protected:
  MainWin & mainwin;

  Gtk::Table * table;
  
  MapSelector ** e_combo_array, ** n_combo_array;

  Gtk::Label * label;

  Gtk::VBox vbox;

public:
  ///Constructor of MapWin creates the widgets shown in MapWin.
  MapWin(const std::string& title, std::vector<std::string>, std::vector<std::string>, MainWin & mw);

  ~MapWin();

  virtual bool on_delete_event(GdkEventAny *);

  void nodeMapChanged(std::string, int);

  void edgeMapChanged(std::string, int);

  void newMapWinNeeded(bool, int);

  ///This function inserts name of the new edgemap in the list in the combo box
  void registerNewEdgeMap(std::string);

  ///This function inserts name of the new nodemap in the list in the combo box
  void registerNewNodeMap(std::string);

  virtual bool closeIfEscapeIsPressed(GdkEventKey*);

  void update(std::vector<std::string>, std::vector<std::string>);
};

#endif //MAP_WIN_H
